Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6265)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6271)
@@ -19,56 +19,87 @@
 #  $HeadURL$
 
-
-## Define Experiment
-if False : 
-    JobName="TEST-CM72-SIMPLE-ROUTING.12" ; TagName="IPSLCM7" ; SpaceName="DEVT" ; ExperimentName="piControl" ; User="p86caub" ; Project="gencmip6" 
-    Freq = 'MO' ; YearBegin = 1970 ; YearEnd = 1979 ; PackFrequency = 10
-    ATM = 'ICO40' ; Routing = 'SIMPLE'
-
-if False :
-    JobName="TEST-CM72-SIMPLE-ROUTING.10" ; TagName="IPSLCM7" ; SpaceName="DEVT" ; ExperimentName="piControl" ; User="p86caub" ; Project="gencmip6" 
-    Freq = 'MO' ; YearBegin = 1860 ; YearEnd = 1869 ; PackFrequency = 10
-    ATM = 'ICO40' ; Routing = 'SIMPLE'
-
-if False : 
-    JobName="VALID-CM622-LR.01" ; TagName="IPSLCM6" ; SpaceName="DEVT" ; ExperimentName="piControl" ; User="p86caub" ; Project="gencmip6" 
-    Freq = 'MO' ; YearBegin = 1890 ; YearEnd = 1899 ; PackFrequency = 10
-    ATM = 'LMD144142' ; Routing = 'ORCHIDEE'
-    
-if True :
-    JobName="CM65v420-LR-SKL-pi-05" ; TagName="IPSLCM6" ; SpaceName="DEVT" ; ExperimentName="piControl" ; User="p48ethe" ; Project="gencmip6" 
-    Freq = 'MO' ;  YearBegin = 1890 ; YearEnd = 1899 ; PackFrequency = 10
-    ORCA = 'eORCA1.2'  ; ATM = 'LMD144142' ; Routing = 'ORCHIDEE' ; NEMO=4.2 ; OCE_relax = False ; OCE_icb = False ; Coupled = True
-    
-Coupled = True
-
-import numpy as np
-##-- Some physical constants
-#-- Earth Radius
-Ra = 40.e6 / (2. * np.pi)
-#-- Gravity
-g = 9.81
-#-- Ice density (kg/m3) in LIM3
-ICE_rho_ice = 917.0
-#-- Snow density (kg/m3) in LIM3
-ICE_rho_sno = 330.0
-#-- Ocean water density (kg/m3) in NEMO
-OCE_rho_liq = 1026.
-
-###
-ICO  = False
-if 'ICO' in ATM : ICO  = True
-LMDZ = False
-if 'LMD' in ATM : LMDZ = True
-
 ###
 ## Import system modules
 import sys, os, shutil, subprocess
+import numpy as np
+import configparser, re
+
+## Creates parser
+config = configparser.ConfigParser()
+config.optionxform = str # To keep capitals
+
+config['Files']  = {}
+config['System'] = {}
+
+##-- Some physical constants
+#-- Earth Radius
+Ra = 6366197.7236758135
+#-- Gravity
+Grav = 9.81
+#-- Ice volumic mass (kg/m3) in LIM3
+ICE_rho_ice = 917.0
+#-- Snow volumic mass (kg/m3) in LIM3
+ICE_rho_sno = 330.0
+#-- Ocean water volumic mass (kg/m3) in NEMO
+OCE_rho_liq = 1026.
+#-- Water volumic mass in atmosphere
+ATM_rho = 1.0e3
+#-- Water volumic mass in surface reservoirs
+SRF_rho = 1.0e3
+#-- Water volumic mass of rivers
+RUN_rho = 1.0e3
+
+## Read experiment parameters
+ATM = None ; ORCA = None ; NEMO = None ; OCE_relax = False ; OCE_icb = False ; Coupled = False ; Routing = None
+
+# Arguments passed
+print ( "Name of Python script:", sys.argv[0] )
+IniFile =  sys.argv[1]
+print ("Input file : ", IniFile )
+config.read (IniFile)
+
+def setBool (chars) :
+    '''Convert specific char string in boolean if possible'''
+    setBool = chars
+    for key in configparser.ConfigParser.BOOLEAN_STATES.keys () :
+        if chars.lower() == key : setBool = configparser.ConfigParser.BOOLEAN_STATES[key]
+    return setBool
+
+def setNum (chars) :
+    '''Convert specific char string in integer or real if possible'''
+    if type (chars) == str :
+        realnum = re.compile ("^[-+]?[0-9]*\.?[0-9]+(e[-+]?[0-9]+)?$")
+        isReal = realnum.match(chars.strip()) != None
+        isInt  = chars.strip().isdigit()
+        if isReal :
+            if isInt : setNum = int   (chars)
+            else     : setNum = float (chars)
+        else : setNum = chars
+    else : setNum = chars
+    return setNum
+
+print ('[Experiment]')
+for VarName in config['Experiment'].keys() :
+    locals()[VarName] = config['Experiment'][VarName]
+    locals()[VarName] = setBool (locals()[VarName])
+    locals()[VarName] = setNum  (locals()[VarName])
+    print ( '{:25} set to : {:}'.format (VarName, locals()[VarName]) )
+
+# ###
+ICO  = ( 'ICO' in ATM )
+LMDZ = ( 'LMD' in ATM )
+    
+###
+## Import system modules
+import sys, os, shutil, subprocess
+import configparser, re
+
+config = configparser.ConfigParser()
+config['Files'] = {}
 
 # Where do we run ?
-TGCC = False ; IDRIS = False
 SysName, NodeName, Release, Version, Machine = os.uname()
-if 'irene'   in NodeName : TGCC  = True
-if 'jeanzay' in NodeName : IDRIS = True
+TGCC  = ( 'irene'   in NodeName )
+IDRIS = ( 'jeanzay' in NodeName )
 
 ## Set site specific libIGCM directories, and other specific stuff
@@ -90,8 +121,9 @@
         
     ## Creates output directory
-    TmpDir = os.path.join ( subprocess.getoutput ( 'ccc_home --cccscratch' ), f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
+    #TmpDir = os.path.join ( subprocess.getoutput ( 'ccc_home --cccscratch' ), f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
+    TmpDir = os.path.join ( '/ccc/scratch/cont003/drf/p86mart', f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
 
 if IDRIS :
-    raise Exception("Pour IDRIS : repertoires et chemins a definir") 
+    raise Exception ("Pour IDRIS : repertoires et chemins a definir") 
 
 ## Import specific module
@@ -99,5 +131,7 @@
 ## Now import needed scientific modules
 import xarray as xr
-    
+
+config['Files'][TmpDir] = TmpDir
+
 # Output file
 FileOut = f'ATM_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
@@ -105,7 +139,8 @@
 
 # Function to print to stdout *and* output file
-def echo (string) :
-    print ( string  )
-    f_out.write ( string + '\n' )
+def echo (string, end='\n') :
+    print ( string, end=end  )
+    sys.stdout.flush ()
+    f_out.write ( string + end )
     f_out.flush ()
     return None
@@ -135,6 +170,6 @@
 
 #-- Model output directories
-if Freq == "MO" : FreqDir =  os.path.join ('Output' , 'MO' )
-if Freq == "SE" : FreqDir =  os.path.join ('Analyse', 'SE' )
+if Freq == "MO" : FreqDir = os.path.join ('Output' , 'MO' )
+if Freq == "SE" : FreqDir = os.path.join ('Analyse', 'SE' )
 dir_ATM_his = os.path.join ( R_SAVE, "ATM", FreqDir )
 dir_SRF_his = os.path.join ( R_SAVE, "SRF", FreqDir )
@@ -145,16 +180,30 @@
 
 #-- Files Names
-if Freq == 'MO' : File = f'{JobName}_{YearBegin}0101_{YearEnd}1231_1M'
-if Freq == 'SE' : File = f'{JobName}_SE_{YearBegin}0101_{YearEnd}1231_1M'
+if Freq == 'MO' : FileCommon = f'{JobName}_{YearBegin}0101_{YearEnd}1231_1M'
+if Freq == 'SE' : FileCommon = f'{JobName}_SE_{YearBegin}0101_{YearEnd}1231_1M'
 
 echo ('\nOpen history files' )
-file_ATM_his = os.path.join (  dir_ATM_his, f'{File}_histmth.nc' )
-file_SRF_his = os.path.join (  dir_SRF_his, f'{File}_sechiba_history.nc' )
+file_ATM_his = os.path.join (  dir_ATM_his, f'{FileCommon}_histmth.nc' )
+file_SRF_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
+if Routing == 'ORCHIDEE'  :
+    file_RUN_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
+if Routing == 'SIMPLE' :
+    file_RUN_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
 
 d_ATM_his = xr.open_dataset ( file_ATM_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
 d_SRF_his = xr.open_dataset ( file_SRF_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
+if Routing == 'ORCHIDEE' :
+    d_RUN_his = d_SRF_his
+if Routing == 'SIMPLE' : 
+    d_RUN_his = xr.open_dataset ( file_RUN_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
 
 echo ( file_ATM_his )
 echo ( file_SRF_his )
+echo ( file_RUN_his )
+
+
+config['Files']['file_ATM_his'] = file_ATM_his
+config['Files']['file_SRF_his'] = file_SRF_his
+config['Files']['file_RUN_his'] = file_SRF_his
 
 ## Compute run length
@@ -170,5 +219,5 @@
 
 #-- Open restart files
-YearRes = YearBegin - 1        # Year of the restart of beginning of simulation
+YearRes = YearBegin - 1              # Year of the restart of beginning of simulation
 YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
 
@@ -219,4 +268,14 @@
         os.system ( command )
 
+config['Files']['file_ATM_beg'] = file_ATM_beg
+config['Files']['file_ATM_end'] = file_ATM_end
+config['Files']['file_SRF_beg'] = file_SRF_beg
+config['Files']['file_SRF_end'] = file_SRF_end
+if Routing == 'SIMPLE' : 
+    config['Files']['file_RUN_beg'] = file_RUN_beg
+    config['Files']['file_RUN_end'] = file_RUN_end
+config['Files']['file_DYN_beg'] = file_DYN_beg
+config['Files']['file_DYN_end'] = file_DYN_end
+        
 echo ('\nOpening ATM SRF and ICO restart files')
 d_ATM_beg = xr.open_dataset ( os.path.join (TmpDir, file_ATM_beg), decode_times=False, decode_cf=True).squeeze()
@@ -228,6 +287,4 @@
 
 for var in d_SRF_beg.variables :
-    #d_SRF_beg[var].attrs['_FillValue'] = 1.e20
-    #d_SRF_end[var].attrs['_FillValue'] = 1.e20
     d_SRF_beg[var] = d_SRF_beg[var].where (  d_SRF_beg[var]<1.e20, 0.)
     d_SRF_end[var] = d_SRF_end[var].where (  d_SRF_end[var]<1.e20, 0.)
@@ -247,30 +304,76 @@
     echo ( file_RUN_end )
 
+def ATM_stock_int (stock) :
+    '''Integrate stock on atmosphere grid'''
+    ATM_stock_int  = np.sum (  np.sort ( (stock * DYN_aire).to_masked_array().ravel()) )
+    return ATM_stock_int
+
+def ATM_flux_int (flux) :
+    '''Integrate flux on atmosphere grid'''
+    ATM_stock_int  = np.sum (  np.sort ( (flux * dtime_per_sec * ATM_aire).to_masked_array().ravel()) )
+    return ATM_stock_int
+
+def ONE_stock_int (stock) :
+    '''Sum stock '''
+    ONE_stock_int  = np.sum (  np.sort ( (stock).to_masked_array().ravel()) )
+    return ONE_stock_int
+
+def ONE_flux_int (flux) :
+    '''Sum flux '''
+    ONE_flux_int  = np.sum (  np.sort ( (flux * dtime_per_sec ).to_masked_array().ravel()) )
+    return ONE_flux_int
+    
 # ATM grid with cell surfaces
-if ICO : 
-    ATM_aire = d_ATM_his ['aire'][0]
-    ATM_fsea = d_ATM_his ['fract_ter'][Ã] + d_ATM_his ['fract_sic'][Ã]
+if ICO :
+    jpja, jpia = d_ATM_his['aire'][0].shape   
+    file_ATM_aire = os.path.join ( R_IN, 'ATM', 'GRID', f'aire_{ATM}_to_{jpia}x{jpja}.nc' )
+    config['Files']['file_ATM_aire'] = file_ATM_aire
+    echo ('Aire sur grille reguliere :', file_ATM_aire)
+    d_ATM_aire = xr.open_dataset ( file_ATM_aire, decode_times=False ).squeeze()
+    ATM_aire = lmdz.geo2point ( d_ATM_aire ['aire'].squeeze(), cumulPoles=True )
+    ATM_fsea = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] + d_ATM_his ['fract_sic'][0] )
+    ATM_flnd = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] + d_ATM_his ['fract_lic'][0] )
+    SRF_aire = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'] )
+    
 if LMDZ :
-    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire'][0] )
-    ATM_fsea = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] + d_ATM_his ['fract_sic'][0] )
-    ATM_aire[0]  = np.sum ( d_ATM_his ['aire'][0, 0] )
-    ATM_aire[-1] = np.sum ( d_ATM_his ['aire'][0,-1] )
+    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire'][0], cumulPoles=True )
+    ATM_fsea = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] + d_ATM_his ['fract_sic'][0] )
+    ATM_flnd = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] )
+    SRF_aire = lmdz.geo2point ( d_SRF_his['Areas'] * d_SRF_his['Contfrac'] )
+
+SRF_aire = SRF_aire.where ( SRF_aire < 1E15, 0.)
 
 if ICO :
+    # Area on icosahedron grid
     file_DYN_aire = os.path.join ( R_IN, 'ATM', 'GRID', ATM+'_grid.nc' )
     d_DYN_aire = xr.open_dataset ( file_DYN_aire, decode_times=False).squeeze()
-    d_DYN_aire = d_DYN_aire.rename( {'cell':'cell_mesh'})
+    d_DYN_aire = d_DYN_aire.rename ( {'cell':'cell_mesh'} )
     DYN_aire   = d_DYN_aire['aire']
+
+    DYN_fsea = d_DYN_aire ['fract_oce'] + d_DYN_aire ['fract_sic']
+    DYN_flnd = 1.0 - DYN_fsea
+    
 if LMDZ :
     DYN_aire = ATM_aire
+    DYN_fsea = ATM_fsea
+    DYN_flnd = ATM_flnd
 
 #if LMDZ :
 #    d_ATM_beg = d_ATM_beg.assign ( coords={'lon':d_ATM_beg.lon*180./np.pi} )
 
-ATM_aire_tot = np.sum (ATM_aire).values.item()
-ATM_aire_sea_tot = np.sum (ATM_aire*ATM_fsea).values.item()
+ATM_aire_sea     = ATM_aire * ATM_fsea
+ATM_aire_sea_tot = ONE_stock_int ( ATM_aire_sea )
+
+ATM_aire_tot     = ONE_stock_int (ATM_aire)
+ATM_aire_sea_tot = ONE_stock_int (ATM_aire*ATM_fsea)
+
+
+echo ( 'Aire atmosphere/4pi R^2 : {:12.5f}'.format(ATM_aire_tot/(Ra*Ra*4*np.pi) ) )
+
+if (  np.abs (ATM_aire_tot/(Ra*Ra*4*np.pi) - 1.0) > 0.01 ) :
+    raise Exception ('Erreur surface interpolee sur grille reguliere')
 
 echo ( '\n------------------------------------------------------------------------------------' )
-echo ( '-- LMDZ changes in stores (for the records)' )
+echo ( '-- ATM changes in stores ' )
 
 #-- Change in precipitable water from the atmosphere daily and monthly files
